unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, db, IBConnection, FileUtil, Forms, Controls,
  Graphics, Dialogs, ExtCtrls, DBGrids, StdCtrls;

const
  sql1 = 'SELECT * FROM COUNTRY';
  sql2 = 'SELECT * FROM COUNTRY where COUNTRY = :COUNTRY';

type

  { TForm1 }

  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    IBConnection1: TIBConnection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  s : string;
begin
  With SQLQuery1 do
  begin
    DisableControls;
    Close;
    SQL.Clear;
    Params.Clear;
    case ComboBox1.ItemIndex of
     0 : SQl.Add(sql1);
      else
      begin
        SQL.Add(sql2);
        Params[0].Text :=  ComboBox1.Text;
      end;
    end;
    Open;
    EnableControls;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IBConnection1.Connected := true;
  With SQLQuery1 do
  begin
    Close;
    DisableControls;
    SQL.Clear;
    Params.Clear;
    SQL.Add('select COUNTRY FROM COUNTRY group by COUNTRY;');
    Open;
    ComboBox1.Items.Clear;
    ComboBox1.Items.Add('ALL');
    First;
    While not Eof do
    begin
      ComboBox1.Items.Add(FieldByName('COUNTRY').AsString);
      Next;
    end;
    Close;
    SQL.Clear;
    SQL.Add(sql1);
    Open;
    EnableControls;
  end;
  ComboBox1.ItemIndex := 0;
end;

end.

